#include <iostream>
#include <iomanip>
#include <fstream>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <float.h>
#include <limits.h>
#include "rof-frm-event-ver310.h"
#include "cell-frm-event-ver310.h"

#ifdef _OPENMP
#include <omp.h>        // OpenMP
#endif

using namespace std;

// 20190511 R搶쐬1bn`f[^ɑΉBn`f[^̕\bPʂŗ^悤ɂB
// 20191013 ./input/dischargeLast.bin ꍇ͑ǑvZ̍ŏȈԗʂlƂēǂݍނ悤ɂB Tanaka T.

//֐̐錾difinition of the function
/*
int makeBasinList(int row, int col, class Cell** object, int*& upperGridNum);
*/
int makeBasinList(int row, int col, class Cell** object, int*& numOfSameBasin, int& numOfCalcCell, int**& orderedCellNum);
void read2DValue(ROF** fROF, int Ndays, int ROFnum_row, int ROFnum_col);
void read2DValueGrads(ROF** fROF, int Ndays, int ROFnum_row, int ROFnum_col);

int main()
{
	cout << "Reading parameters for runoff simulation." << endl;
	ifstream finParam("./param-frm-event-ver410.dat");
	if(!finParam){
		cout << "param-frm-event-ver300.dat cannot open." << endl;
	}

	// vZ̈ simulation range
	cout << "1) Reading parameters for study area." << endl;

	float wTopoScale;

	finParam >> wTopoScale;
	cout << "  Topography scale : " << wTopoScale << endl;

	int wCol,wRow;
	double wSWLON, wSWLAT;

	finParam >> wCol; 
	finParam >> wRow; 
	cout << "  Number of col : " << wCol << "  Number of row : " << wRow << endl;

	finParam >> wSWLON; 
	finParam >> wSWLAT;
	cout << " Sorth West corner Longitude (degree) : " << wSWLON 
		 << " Latitude (deg) : " << wSWLAT << endl;

	const float TopoScale = wTopoScale; // DEM ̕\bPʂŐݒ肷 set DEM resolution with second
	const int Col = wCol;     // column number of study area
	const int Row = wRow;     // row number of study area
	const double SWLON = wSWLON; // South west corner of longitude (degree)
	const double SWLAT = wSWLAT; // South west corner of latiitude (degree)

	// ̓f[^̈ input data range
	cout << "2) Reading parameters for input data." << endl;

	int wROFnum_col, wROFnum_row;
	double wDelta_x, wDelta_y, wROF_WLON, wROF_SLAT;
	finParam >> wROFnum_col;
	finParam >> wROFnum_row;
	cout << "  Number of col : " << wROFnum_col 
		 << "  Number of row : " << wROFnum_row << endl;

	finParam >> wDelta_x;
	finParam >> wDelta_y;
	cout << "  Input data grid size of x-direction : " << wDelta_x << endl;
	cout << "  Input data grid size of y-direction : " << wDelta_y << endl;

	finParam >> wROF_WLON; 
	cout << "  Longitude of the center of the Southwest corner of input data (degree) : " << wROF_WLON << endl;
	finParam >> wROF_SLAT; 
	cout << "  Latitude of the center of the Southwest corner of input data (degree) : " << wROF_SLAT << endl;
													
	const int ROFnum_col = wROFnum_col;
	const int ROFnum_row = wROFnum_row; 
	const double Delta_x = wDelta_x;
	const double Delta_y = wDelta_y;
	const double ROF_WLON = wROF_WLON;
	const double ROF_SLAT = wROF_SLAT;

	// vZ simulation term
	cout << "3) Reading parameters for simuration duration." << endl;
	int wNdays;
	finParam >> wNdays;
	cout << "  Simulation duration (days) : " << wNdays << endl;

	const int Ndays = wNdays; // Simulation duration (days)

	//  finite difference condition
	cout << "4) Reading parameters for finite difference condition." << endl;
	int wTime_Step, wNspace; double wTheta;
	finParam >> wTime_Step; cout << "  Finite difference time step (sec) : " << wTime_Step << endl;
	finParam >> wNspace; cout << "  Finite difference space step : " << wNspace << endl;
	finParam >> wTheta; cout << "  Finite difference weight : " << wTheta << endl;

	const int Time_Step = wTime_Step; // vZ̎ԊԊu [sec] similation time step [sec] */
	const int Nspace = wNspace; /* vZ̋ԕ number of spatial divisions */
	const double Theta = wTheta; 	/* d݌W (-) 0.5 < theta <= 1.0 */
	const int Ntime = 3600/Time_Step;  // ̓f[^Ԋu(1)ł̌vZ

	// model parameter setting for runoff simulation vZ̃p^
	cout << "5) Reading parameters for kinematic wave model." << endl;
	double wMan_slope, wMan_channel; int wThreshold_basin;
	finParam >> wMan_slope; cout << "  Manning roughmess coefficient for slope [m/s] : " << wMan_slope << endl;
	finParam >> wMan_channel; cout << "  Manning roughmess coefficient for channel [m/s] : " << wMan_channel << endl;
	finParam >> wThreshold_basin; cout << "  Area to classify slope and channel : " << wThreshold_basin << endl;

	const double Man_slope   =  wMan_slope; // Ζʂł̑exW for slope
	const double Man_channel = wMan_channel; // ͓ł̑exW for river
	const int Threshold_basin = wThreshold_basin; // WObh臒libasin > threshold_basin ݂Obh͓ɂȂj

	/* initial condi */
	cout << "6) Reading itinial discharge for kinematic wave model." << endl;
	double winitialROF;
	finParam >> winitialROF; cout << "  Initial runoff height [mm/hr] : " << winitialROF << endl;
	const double intialROF = winitialROF; /* initial runoff height [mm/hr] */

	finParam.close();
	//--------------------- end parameter reading ------------------------------------------------


	//ϐ̒` dif-variables
	int iday, ihour, dt;
	int n, k;
	bool executeOrPass = false;
	//errno_t error;
	
	FILE *fCorrectedMed;
	float med;

	FILE *fDown;
	FILE *fBasin;
	FILE *fRiverNumber;

	float ROFlat;
	float ROFlon;
	char DischargeFileName[256];
	char ConditionFileName[256];
	int* upperGridNum;
	int* numOfSameBasin;
	int** orderedCellNum;
	int numOfBasin;
	int numOfCalcCell;

	// reading watershed numbers for simulation from riverNumList.dat vZ闬̔ԍ̐ݒ
	ifstream fin1("./topoData/riverNumList.dat");
	if(!fin1){
		cout << "riverNumList.dat cannot open.\n";
		return 1;
	}

	int size_riverNumber_cal=0;
	string ss;

	while (getline(fin1, ss)) { // count number of rivers.  ΏۂƂ͐쐔𒲂ׂ
		size_riverNumber_cal++; 
	}
	fin1.close();
	cout << "Number of rivers for simulation : " << size_riverNumber_cal << endl << endl;

	int* riverNumber_cal;
	riverNumber_cal = new int[size_riverNumber_cal];

	ifstream fin2("./topoData/riverNumList.dat");
	if(!fin2){
		cout << "riverNumList.txt cannot open.\n";
		return 1;
	}
	int iriver, icol, irow, ilat, ilon, iarea;
	double dlon, dlat;
	for(int i=0; i<size_riverNumber_cal; i++){ // setting river number for simulation
		fin2 >> iriver >> iarea >> icol >> irow >> ilon >> ilat >> dlon >> dlat;
		riverNumber_cal[i]=iriver;
	}
	fin2.close();

	// Memory assignment for grid cell of simulation
	class Cell** cellObject; 
	cellObject = new class Cell*[Row];
	for(int i=0; i<Row; i++){
		cellObject[i] = new class Cell[Col];
	}

	// Memory assignment for data cell of input data
	class ROF** rofObject;
	rofObject = new class ROF*[ROFnum_row];
	for(int i=0; i<ROFnum_row; i++){
		rofObject[i] = new class ROF[ROFnum_col];
	}

	/*--- ̓f[^IuWFNgɏ ---*/
	//eIuWFNgɈܓxEox
	for(int i=0; i<ROFnum_row; i++){
		//ROFlat = ROF_SLAT + 0.5*Delta_y + i*Delta_y ;  // set latitude
		ROFlat = ROF_SLAT + i*Delta_y ;  // set latitude. Runoff grid is the center.
		for(int j=0; j<ROFnum_col; j++){
			//ROFlon = ROF_WLON +  0.5*Delta_x + j*Delta_x; // set longitude 
			ROFlon = ROF_WLON +  j*Delta_x; // set longitude  Runoff grid is the center.
			rofObject[i][j].setInformation(&ROFlat, &ROFlon, j, i, Ndays);
		}
	}
	//cout << "ROF data setting end." << endl;

	/*--- [͓ԁEoϐɒl set the sream informations ---*/

	/* latitude  longitude  longitudinalLength  med */
	//if(error = fopen_s(&fCorrectedMed, "./topoData/modDem.bin", "rb") != NULL) {
	if ((fCorrectedMed = fopen("./topoData/modDem.bin", "rb")) == NULL) {
		cout << "modDem.bin cannot open." << endl;
		exit(1);
	}

	for(int i=Row-1; i>=0; i--) { // DEM data arranges from south to north
		for(int j=0; j<Col; j++) {
			fread(&med, sizeof(float), 1, fCorrectedMed);
			cellObject[i][j].setElevation(i, j, Row, Col, SWLAT, SWLON, med, TopoScale);
			cellObject[i][j].setNULL();
			//cout << "row=" << i << " col=" << j << endl;
		}
	}
	fclose(fCorrectedMed);

	/* down  basin downStreamGrid riverNumber */
	//if(error = fopen_s(&fDown, "./topoData/flowDir.bin", "rb") != NULL) {
	if ((fDown = fopen("./topoData/flowDir.bin", "rb")) == NULL) {
		cout << "flowDir.bin cannot open." << endl;
		exit(1);
	}

	//if(error = fopen_s(&fBasin, "./topoData/flowAcc.bin", "rb") != NULL) {
	if ((fBasin = fopen("./topoData/flowAcc.bin", "rb")) == NULL) {
		cout << "flowAcc.bin cannot open." << endl;
		exit(1);
	}

	//if(error = fopen_s(&fRiverNumber, "./topoData/riverNum.bin", "rb") != NULL) {
	if ((fRiverNumber = fopen("./topoData/riverNum.bin", "rb")) == NULL) {
		cout << "riverNum.bin cannot open." << endl;
		exit(1);
	}

	for(int i=Row-1; i>=0; i--) { // Topo data arranges from south to north
		for(int j=0; j<Col; j++) {

			fread(&cellObject[i][j].down, sizeof(int), 1, fDown);
			fread(&cellObject[i][j].basin, sizeof(int), 1, fBasin);
			fread(&cellObject[i][j].riverNumber, sizeof(int), 1, fRiverNumber);

			if(cellObject[i][j].riverNumber < 0) {
				continue;
			}
			cellObject[i][j].setDownStreamGrid(i, j, cellObject);
		}
	}

	fclose(fDown);
	fclose(fBasin);
	fclose(fRiverNumber);

	/* upStreamGrid riverNumber */
	for(int i=0; i<Row; i++){
		for(int j=0; j<Col; j++)	{
			if(cellObject[i][j].riverNumber < 0 || cellObject[i][j].isThisGridEnd==true || cellObject[i][j].down==0) {
				continue;
			}
			//cout << i << ", " << j << endl;
			cellObject[i][j].setUpStreamGrid();
		}
	}

	/* numberOfUpStreamGrid */
	for(int i=0; i<Row; i++){
		for(int j=0; j<Col; j++){
			if(cellObject[i][j].riverNumber < 0 || cellObject[i][j].isThisGridEnd==true) {
				continue;
			}
			cellObject[i][j].countNumberOfUpStreamGrid();
		}
	}



	/* ROFCell ԗʂ p^ set parameters */
	// Revised by Tachikawa using code developed by T. Tanaka June 2 2019

	// old program
/*
	for(int i=0; i<Row; i++){
		for(int j=0; j<Col; j++){
			
			if(cellObject[i][j].riverNumber < 0 || cellObject[i][j].isThisGridEnd == true) {
				continue;
			}

			cellObject[i][j].setROFCell(rofObject, ROFnum_row, ROFnum_col);
			cellObject[i][j].Set_parameter(Man_slope, Man_channel, Threshold_basin, 
				Nspace, Time_Step, Theta, Ntime, Ndays);
			cellObject[i][j].initialize(intialROF);
		}
	}	
*/


	/*--- ROFCell ԗʂ p^ set parameters ---*/
	
	// originally edited by matsubara 2013
	// Revised by Tanaka T. 10/18/2015
	int ROFnum_col_data = -9999;
	int ROFnum_row_data = -9999;
	double Delta_x_data = -9999.0;
	double Delta_y_data = -9999.0;
	double ROF_WLON_data = -9999.0;
	double ROF_SLAT_data = -9999.0;;
	sprintf(ConditionFileName, "./temp/setROFCell.dat");
	ifstream fsrc(ConditionFileName);
	if(fsrc){
		
		fsrc >> ROFnum_col_data;
		fsrc >> ROFnum_row_data;
		fsrc >> Delta_x_data;
		fsrc >> Delta_y_data;
		fsrc >> ROF_WLON_data;
		fsrc >> ROF_SLAT_data;
	}
	fsrc.close(); 

	//p[^t@CƓ̓f[^t@C̍Wl̍
	double resDx = fabs(Delta_x-Delta_x_data);
	double resDy = fabs(Delta_y-Delta_y_data);
	double resLon = fabs(ROF_WLON_data-ROF_WLON);
	double resLat = fabs(ROF_SLAT_data-ROF_SLAT);
	if(
		ROFnum_col_data != ROFnum_col ||
		ROFnum_row_data != ROFnum_row ||
		resDx > DBL_MIN ||
		resDy > DBL_MIN ||
		resLon> DBL_MIN ||
		resLat> DBL_MIN )
	{
	//setROFCell.dat݂Ȃ܂para-event2.datƐȂꍇ͐Vɍ 2015/10/18 Tanaka T.
	//vZ@ɍ킹āAǂݍ񂾃f[^̏_ȉ̌ɍ킹덷ݒ肷 2015/10/18 Tanaka T.
		//cout << "cannot open " << ConditionFileName << " or " 
		//	<< ConditionFileName << " and param-event-ver2.dat does not match" << endl;
		cout << "Make ROF data " << ConditionFileName << endl;

		ofstream fsrc(ConditionFileName); 
		if(!fsrc){
			cout << ConditionFileName << " cannot open.\n";
			//exit(1);
		}
		
		fsrc <<	ROFnum_col << endl;
		fsrc <<	ROFnum_row << endl;
		fsrc <<	setprecision(15) << Delta_x << endl;
		fsrc <<	setprecision(15) << Delta_y << endl;
		fsrc <<	setprecision(15) << ROF_WLON << endl;
		fsrc <<	setprecision(15) << ROF_SLAT << endl;
		
		int ix, iy;
		for(int i=0; i<Row; i++){
			for(int j=0; j<Col; j++){
				int *rofRC= new int[2];//0: Row, 1: Column
				cellObject[i][j].setROFCell(rofObject, ROFnum_row, ROFnum_col, rofRC);
				fsrc << i << " " << j << " " << rofRC[0] << " " << rofRC[1] << endl;
			}
		}
		fsrc.close();
	}
	else{ // t@C݂ꍇ́Ałɍ쐬ꂽt@Cǂ
		cout << "Read ROF data from " << ConditionFileName << endl;
		
		ifstream fsrc(ConditionFileName);

		fsrc >> ROFnum_col_data;
		fsrc >> ROFnum_row_data;
		fsrc >> Delta_x_data;
		fsrc >> Delta_y_data;
		fsrc >> ROF_WLON_data;
		fsrc >> ROF_SLAT_data;

		int ii, jj, ix, iy;
		for(int i=0; i<Row; i++){
			for(int j=0; j<Col; j++){
				fsrc >> ii >> jj >> ix >> iy ;
				cellObject[i][j].PutROFCell(rofObject, ix, iy);
			}
		}
		fsrc.close();
	}
	



	// p^̐ݒ set parameters and initial conditions
	cout << "Setting parameter data." << endl;
	for(int i=0; i<Row; i++){
		for(int j=0; j<Col; j++){
			
			if(cellObject[i][j].riverNumber < 0 || cellObject[i][j].isThisGridEnd == true) {
				continue;
			}

			cellObject[i][j].Set_parameter(Man_slope, Man_channel, Threshold_basin, 
				Nspace, Time_Step, Theta, Ntime, Ndays);
			
//			cellObject[i][j].initialize(intialROF);
		}
	}

	// ԗʂ̏ set initial condition revised by Tanaka T. 2019/10/12
	// 20191013 ./input/dischargeLast.bin ꍇ͑ǑvZ̍ŏȈԗʂlƂēǂݍނ悤ɂB Tanaka T.
	ifstream finInit("./input/dischargeLast.bin");
	if(!finInit){
		cout << "Setting initial condition using steady runoff : " << intialROF << endl;
		
		for(int i=0; i<Row; i++){
			for(int j=0; j<Col; j++){
				
				if(cellObject[i][j].riverNumber < 0 || cellObject[i][j].isThisGridEnd == true) {
					continue;
				}
				
				cellObject[i][j].initialize(intialROF);
			}
		}
	}
	else{
		cout << "Read initial discharge from ./input/dischargeLast.bin." << endl;
		
		for(int ix=0; ix<=Nspace; ix++){
			
			for(int m=Row-1; m >=0; m--){ // latitude direction from South for Grads format
				for(n=0; n<Col; n++){     // longitude direction from West
					
					double initQ;
					finInit.read((char*)&initQ, sizeof(double));
					
					if(initQ >= 0.0){
						
						cellObject[m][n].mQc[ix] = initQ;
						cellObject[m][n].mQn_memory[0][0][0] = (float)initQ;
					}
				}
			}
		}
		
		finInit.close();
	}
	


	/*--- ʌvZ̐ arrange calculation order ---*/
	int Col_data = -9999;
	int Row_data = -9999;
	double SWLON_data = -9999.0;
	double SWLAT_data = -9999.0;

	sprintf(ConditionFileName, "./temp/numOfBasin.dat");
	ifstream finNB(ConditionFileName);
	int *rnumOfSameBasin;

	//t@C݂ꍇ́A܂t@C̒n`ǂݎ
	if(finNB){
		finNB >> Col_data;
		finNB >> Row_data;
		finNB >> SWLON_data;
		finNB >> SWLAT_data;
	}
	finNB.close();

	//p[^t@CƓ̓f[^t@C̍Wl̍
	double resLon2 = fabs(SWLON_data - SWLON);
	double resLat2 = fabs(SWLAT_data - SWLAT);

	//t@C̑ݗLђn`̐mF
	if(Col_data !=	Col ||
	   Row_data !=	Row ||
	   resLon2 > DBL_MIN ||
	   resLat2 > DBL_MIN )
	{//numOfBasin.dat݂Ȃ܂para-event2.datƐȂꍇ͐Vɍ 2015/10/18 Tanaka T.
	//vZ@ɍ킹āAǂݍ񂾃f[^̏_ȉ̌ɍ킹덷ݒ肷 2015/10/18 Tanaka T.
	//cout << "cannot open " << ConditionFileName << " or " 
	//	<< ConditionFileName << " and param-event-ver2.dat does not match" << endl;
		cout << "Make basinList data " << ConditionFileName << endl;

		numOfBasin = makeBasinList(Row, Col, cellObject, numOfSameBasin, numOfCalcCell, orderedCellNum);

		ofstream foutNB(ConditionFileName);
		if(!foutNB){
			cout << ConditionFileName << " cannot open.\n";
			//exit(1);
		}
		
		foutNB << Col << endl;
		foutNB << Row << endl;
		foutNB << setprecision(15) << SWLON << endl;
		foutNB << setprecision(15) << SWLAT << endl;
		
		foutNB << numOfBasin << endl ;
		foutNB << numOfCalcCell << endl ;

		for(int i=0; i<numOfBasin; i++){
			foutNB << numOfSameBasin[i] << endl ;
		}
		foutNB.close();

		cout << "Make calculation order data ./temp/orderedCell.dat" << endl;
		ofstream foutOrderedCell("./temp/orderedCell.dat");
		if(!foutOrderedCell){
			cout << "./temp/orderedCell.dat cannot open.\n";
			//exit(1);
		}
		
		for(int i=0; i<numOfCalcCell; i++){
			foutOrderedCell << cellObject[orderedCellNum[i][0]][orderedCellNum[i][1]].basin << " " 
				<< orderedCellNum[i][0] << " " 
				<< orderedCellNum[i][1] << endl;
		}
		foutOrderedCell.close();

	}
	else{  // t@C݂ꍇ́Ałɍ쐬ꂽt@Cǂ
		ifstream finNB(ConditionFileName);
		cout << "Read basinList data from " << ConditionFileName << endl;

		finNB >> Col_data;
		finNB >> Row_data;
		finNB >> SWLON_data;
		finNB >> SWLAT_data;
		finNB >> numOfBasin;
		finNB >> numOfCalcCell;
		
		numOfSameBasin = new int[numOfBasin];
		for(int i=0; i<numOfBasin; i++){
			finNB >> numOfSameBasin[i];
		}
		finNB.close();

		ifstream finOrderedCell("./temp/orderedCell.dat");
		if(!finOrderedCell){
			cout << "./temp/orderedCell.dat cannot open.\n";
			exit(1);
		}
		cout << "Read calculation order data from ./temp/orderedCell.dat" << endl << endl;
		
		orderedCellNum = new int*[numOfCalcCell];
		for(int i=0; i<numOfCalcCell; i++){
			orderedCellNum[i] = new int[2];
		}
		int ii;
		for(int i=0; i<numOfCalcCell; i++){
			finOrderedCell >> ii >> orderedCellNum[i][0] >> orderedCellNum[i][1];
		}
		finOrderedCell.close();
	}




	// --- ovZ runoff simulation ---
	cout << endl;
	cout << "Number of different kind of cell accumulattion number : " << numOfBasin << endl;
	cout << "Number of calculation cell number : " << numOfCalcCell << endl;
	cout << "Total simulation time is " << Ndays << " days." << endl << endl; 
	
	// Read 2-dimensional input data
	read2DValue(rofObject, Ndays, ROFnum_row, ROFnum_col);

	// Reading monthly input data with Grads format
	//read2DValueGrads(rofObject, Ndays, ROFnum_row, ROFnum_col);

	int startBasin, endBasin;
	cout << "Runoff simulation starts." << endl; 
	for(int ib=0; ib<numOfBasin; ib++){ // ʐς̏̂珇ɌvZB
		//cout << "  " <<  setprecision(3) << ((double)ib+1.0)/((double)numOfBasin)*100 << "% ends.\n";
		
		if(ib == 0){
			startBasin = 0;
		}
		else{ 
			startBasin = endBasin + 1;
		}
		endBasin = startBasin + numOfSameBasin[ib] - 1;
		cout << "  " <<  setprecision(3) << startBasin+1<<"/"<< numOfCalcCell << " ends.\n";

		#pragma omp parallel for private(iday, ihour, dt, executeOrPass, k)
		for(int i=startBasin; i<=endBasin; i++){ // the same basin group
			if(cellObject[orderedCellNum[i][0]][orderedCellNum[i][1]].isThisGridEnd==true) { 
				// edge of study area 
				continue;
			}
			
			// w肵ɑObĥ݁Aȉ̑s 
			// Only catchments specified in 'riverNumberList.txt' is calculated.
			executeOrPass = false;

			for(k=0; k<size_riverNumber_cal; k++){
				if(cellObject[orderedCellNum[i][0]][orderedCellNum[i][1]].riverNumber == riverNumber_cal[k]){
					executeOrPass = true;
					break;
				}
			}

			if(executeOrPass == false) {
				continue;
			}

			// runoff simulation
			for(iday=1; iday <= Ndays; iday++){ // day loop
				for(ihour=1; ihour<=24; ihour++){ // hour loop
					cellObject[orderedCellNum[i][0]][orderedCellNum[i][1]].getLateralRunoff(iday, ihour);
					for(dt=0; dt<Ntime; dt++){ // simulation time step roop 
						cellObject[orderedCellNum[i][0]][orderedCellNum[i][1]].Calculate(iday, ihour, dt);
					}
				}
			}
		} 			
	} // runoff simulation loop end. ovZIB

	cout << endl; 
	cout << "Runoff simulation ends." << endl; 

	// writing simulated data to files
	ofstream FileDaily; // Daily flow
	//sprintf_s(DischargeFileName, 256, "./output/dischargeDaily.bin");
	sprintf(DischargeFileName, "./output/dischargeDaily.bin");
	cout << "Write " << DischargeFileName << endl;
	FileDaily.open(DischargeFileName, ios::out | ios::binary);
	
	ofstream FileHourlyMax; // Maximum hourly data in a day
	//sprintf_s(DischargeFileName, 256, "./output/dischargeHourlyMaxInDay.bin");
	sprintf(DischargeFileName, "./output/dischargeHourlyMaxInDay.bin");
	cout << "Write " << DischargeFileName << endl;
	FileHourlyMax.open(DischargeFileName, ios::out | ios::binary);

	ofstream FileHourly; // Hourly data
	//sprintf_s(DischargeFileName, 256, "./output/dischargeHourly.bin");
	sprintf(DischargeFileName, "./output/dischargeHourly.bin");
	cout << "Write " << DischargeFileName << endl;
	FileHourly.open(DischargeFileName, ios::out | ios::binary);

	/*--- for debugging --------------------------------------------*/
	//ofstream FileTest; // Point hourly data
	//sprintf_s(DischargeFileName, 256, "./output/dischargeTest.dat");
	////sprintf(DischargeFileName, "./output/dischargeTest.dat");
	//cout << "Write " << DischargeFileName << endl;
	//FileTest.open(DischargeFileName);
	/*--- for debugging--------------------------------------------- */

	float Nodata=-9999;
	for(iday=0; iday < Ndays; iday++){
		float dailyFlow; // m3/hr
		float hourlyFlowMax; // m3/hr
		float hourlyFlow; // m3/hr
			
		for(int m=Row-1; m >=0; m--){ // latitude direction from South for Grads format
			for(n=0; n<Col; n++){     // longitude direction from West
				if(cellObject[m][n].isThisGridEnd==true){
					FileDaily.write((char*)&Nodata, sizeof(float));
					FileHourlyMax.write((char*)&Nodata, sizeof(float));
					continue;
				}
				// w肵ɑȂObhɂ false ݒ肷B 
				// 'false' is set to the grids of outside study area.
				executeOrPass = false;
				for(k=0; k<size_riverNumber_cal; k++){
					if(cellObject[m][n].riverNumber == riverNumber_cal[k]){
						executeOrPass = true;
						break;
					}
				}
				if(executeOrPass == false){ // ΏۊÕObhł Nodata Ń[vi߂B
					FileDaily.write((char*)&Nodata, sizeof(float));
				    FileHourlyMax.write((char*)&Nodata, sizeof(float));
					continue;
				}
					
				dailyFlow = (float) cellObject[m][n].GetDailyFlow(iday, Ntime);
				FileDaily.write((char*)&dailyFlow, sizeof(float));

				hourlyFlowMax = (float) cellObject[m][n].GetHourlyFlowMax(iday, Ntime);
				FileHourlyMax.write((char*)&hourlyFlowMax, sizeof(float));
			}
		}

		for (ihour=0; ihour < 24; ihour++) {
			for(int m=Row-1; m >=0; m--){ // latitude direction from South for Grads format
				for(n=0; n<Col; n++){     // longitude direction from West
					if(cellObject[m][n].isThisGridEnd==true){
						FileHourly.write((char*)&Nodata, sizeof(float));
						continue;
					}
					// w肵ɑȂObhɂ false ݒ肷B 
					// 'false' is set to the grids of outside study area.
					executeOrPass = false;
					for(k=0; k<size_riverNumber_cal; k++){
						if(cellObject[m][n].riverNumber == riverNumber_cal[k]){
							executeOrPass = true;
							break;
						}
					}
					if(executeOrPass == false){ // ΏۊÕObhł Nodata Ń[vi߂B
						FileHourly.write((char*)&Nodata, sizeof(float));
						continue;
					}

					hourlyFlow = (float) cellObject[m][n].GetHourlyFlow(iday, ihour, Ntime);
					FileHourly.write((char*)&hourlyFlow, sizeof(float));
				}
			}
		}
		/*--- File output for debugging by YT -------------------------------------------------*/
		//int outCol = 59; // begin from 1 from east
		//int outRow = 22; // begin from 1 from south
		//outRow = Row -outRow + 1; // change from north
		//for (ihour=0; ihour < 24; ihour++) {
		//	hourlyFlow = (float) cellObject[outRow-1][outCol-1].GetHourlyFlow(iday, ihour, Ntime);
		//	FileTest << iday+1 << " " << ihour << " " << hourlyFlow << endl;
		//}
		/*---debugging--------------------------------------------------------------------------*/
	}

	FileDaily.close();
	FileHourlyMax.close();
	FileHourly.close();
	
	// 20191013 ŏȈԗʂo悤ɂB Tanaka T.
	// Output all the state variables mQn at the last time
	ofstream FileLastData; // Hourly data
	sprintf(DischargeFileName, "./output/dischargeLast.bin");
	cout << "Write " << DischargeFileName << endl;
	FileLastData.open(DischargeFileName, ios::out | ios::binary);
	double mQn;
	double Nodata_double = (double)Nodata;
	for(int ix=0; ix <= Nspace; ix++){
		for(int m=Row-1; m >=0; m--){ // latitude direction from South for Grads format
			for(n=0; n<Col; n++){     // longitude direction from West
				if(cellObject[m][n].isThisGridEnd==true){
					FileLastData.write((char*)&Nodata_double, sizeof(double));
					continue;
				}
				// w肵ɑȂObhɂ false ݒ肷B 
				// 'false' is set to the grids of outside study area.
				executeOrPass = false;
				for(k=0; k<size_riverNumber_cal; k++){
					if(cellObject[m][n].riverNumber == riverNumber_cal[k]){
						executeOrPass = true;
						break;
					}
				}
				if(executeOrPass == false){ // ΏۊÕObhł Nodata Ń[vi߂B
					FileLastData.write((char*)&Nodata_double, sizeof(double));
					continue;
				}
				
				mQn = cellObject[m][n].mQn[ix];
				FileLastData.write((char*)&mQn, sizeof(double));
			}
		}
	}
	FileLastData.close();
	
	
	/*--- debugging ------------------*/
	//FileTest.close();
	/*---------------------------------*/


	for(int i=0; i<Row; i++){
		for(int j=0; j<Col; j++){
			if(cellObject[i][j].isThisGridEnd==true || cellObject[i][j].riverNumber < 0){
				continue;
			}
			cellObject[i][j].deleteQandA(Ndays);
		}
	}

	for(int i=0; i<Row; i++){
		delete[] cellObject[i];
	}
	delete[] cellObject;

	for(int i=0; i<ROFnum_row; i++){
		delete[] rofObject[i];
	}
	delete[] rofObject;

	//delete[] upperGridNum;

	return 0;
}


//	֐̒`

//ovZŽvZݒ肷
//vZ̕ύX 2014/11/30 Tanaka T.
int makeBasinList(int row, int col, class Cell** object, int*& numOfSameBasin, int& numOfCalcCell, int**& orderedCellNum)
{
	//dĂȂWZ
	int num = 0;

	int** basin;

	basin = new int*[row];
	for(int i=0; i<row; i++){
		
		basin[i] = new int[col];
	}


	//eIuWFNgbasinzbasinɂ
	for(int i=0; i<row; i++){
		for(int j=0; j<col; j++){
			basin[i][j] = object[i][j].basin;
		}
	}

	//ɕבւ
	int tmp;

	//̂ƂɁCבւi,jԖڂ̃ẐƂƂ̃ZԍLĂ 2014/11/28 Tanaka
	int ***org = new int**[row];
	int itmp;
	for(int i=0; i<row; i++){
		org[i] = new int*[col];
	}
	for(int i=0; i<row; i++){
		for(int j=0; j<col; j++){
			org[i][j] = new int[2];
		}
	}
	for(int i=0; i<row; i++){
		for(int j=0; j<col; j++){
//			org[i][j][0] = -9999;
//			org[i][j][1] = -9999;
			org[i][j][0] = i;
			org[i][j][1] = j;
		}
	}


	for(int i=0; i<row; i++){
		for(int j=0; j<col; j++){
			
			for(int jj=j+1; jj<col; jj++){

				if(basin[i][j] > basin[i][jj]){

					tmp = basin[i][j];
					basin[i][j] = basin[i][jj];
					basin[i][jj] = tmp;

					//ƂƂ̃ZԍL
					itmp = org[i][j][0];
					org[i][j][0] = org[i][jj][0];
					org[i][jj][0] = itmp;
					itmp = org[i][j][1];
					org[i][j][1] = org[i][jj][1];
					org[i][jj][1] = itmp;
				}
			}
			
			for(int ii=i+1; ii<row; ii++){
				for(int jj=0; jj<col; jj++){

					if(basin[i][j] > basin[ii][jj]){

						tmp = basin[i][j];
						basin[i][j] = basin[ii][jj];
						basin[ii][jj] = tmp;

						//ƂƂ̃ZԍL
						itmp = org[i][j][0];
						org[i][j][0] = org[ii][jj][0];
						org[ii][jj][0] = itmp;
						itmp = org[i][j][1];
						org[i][j][1] = org[ii][jj][1];
						org[ii][jj][1] = itmp;
					}
				}
			}

		}
	}


	//zbasin̗vfɏdĂȂ͉邩
	int dammy = 0;
	for(int i=0; i<row; i++){
		for(int j=0; j<col; j++){
			
			if(basin[i][j] > 0 && basin[i][j] != dammy){
				dammy = basin[i][j];
				num++;
			}
		}
	}

	//z upperGridNum ̃m
	int *upperGridNum = new int[num];

	//z upperGridNum basin̒lɓ
	//̎_dammybasin̍őlDbasin[0][0]Ƃ͕KقȂ邩dammybasin[0][0]ɒuD
	int k=0;
	for(int i=0; i<row; i++){
		for(int j=0; j<col; j++){
			if(basin[i][j] > 0){
				if(basin[i][j] != dammy){
					*(upperGridNum+k) = basin[i][j];
					dammy = basin[i][j];
					k++;
				}
			}
		}
	}

	//basin̒lŽ𐔂 2014/11/28 Tanaka
	//܂C̈ԏbasin̒ldammyɓ
	numOfSameBasin = new int[num];
	for(int i=0; i<num; i++){
		numOfSameBasin[i]=0;
	}
	for(int i=0; i<row; i++){
		for(int j=0; j<col; j++){
			if(basin[i][j] > 0 && basin[i][j] < dammy){
				dammy = basin[i][j];
			}
		}
	}
	k=0;
	numOfCalcCell = 0;
	for(int i=0; i<row; i++){
		for(int j=0; j<col; j++){
			if(basin[i][j] > 0){
				numOfCalcCell++;
				
				if(basin[i][j] != dammy){
					dammy = basin[i][j];
					k++;
					numOfSameBasin[k]++;
				}
				else{
					numOfSameBasin[k]++;
				}
			}
		}
	}

	//z orderedCellNum basin̒l̏ɕבւZ̔ԍ 2014/11/28 Tanaka
	orderedCellNum = new int*[numOfCalcCell];
	for(int i=0; i<numOfCalcCell; i++){
		orderedCellNum[i] = new int[2];
	}
	for(int i=0; i<numOfCalcCell; i++){
		for(int j=0; j<2; j++){
			orderedCellNum[i][j] = -9999;
		}
	}
	int sameBi=0;
	for(int i=0; i<row; i++){
		for(int j=0; j<col; j++){
			if(basin[i][j] > 0){
				orderedCellNum[sameBi][0] = org[i][j][0];
				orderedCellNum[sameBi][1] = org[i][j][1];
				sameBi++;
			}
		}
	}

	for(int i=0; i<row; i++){
		delete[] basin[i];
	}
	delete[] basin;
	/*------------------------------------------------------------------*/

	return num;
}


/*
int makeBasinList(int row, int col, class Cell** object, int*& upperGridNum)
{
	int** basin;

	basin = new int*[row];
	for(int i=0; i<row; i++){
		
		basin[i] = new int[col];
	}


	//eIuWFNgbasinzbasinɂ
	for(int i=0; i<row; i++){
		for(int j=0; j<col; j++){
			basin[i][j] = object[i][j].basin;
		}
	}

	//ɕבւ
	int tmp;

	for(int i=0; i<row; i++){
		for(int j=0; j<col; j++){
			
			for(int jj=j+1; jj<col; jj++){
				
				if(basin[i][j] > basin[i][jj]){
					
					tmp = basin[i][j];
					basin[i][j] = basin[i][jj];
					basin[i][jj] = tmp;
				}
			}
			
			for(int ii=i+1; ii<row; ii++){
				for(int jj=0; jj<col; jj++){
					
					if(basin[i][j] > basin[ii][jj]){
						
						tmp = basin[i][j];
						basin[i][j] = basin[ii][jj];
						basin[ii][jj] = tmp;
					}
				}
			}
			
		}
	}

	//zbasin̗vfɏdĂȂ͉邩
	int num = 0;
	int dammy = 0;

	for(int i=0; i<row; i++){
		for(int j=0; j<col; j++){
			
			if(basin[i][j] > 0 && basin[i][j] != dammy){
				dammy = basin[i][j];
				num++;
			}
		}
	}

	//z upperGridNum ̃m
	upperGridNum = new int[num];

	//z upperGridNum basin̒lɓ
	int k=0;
	for(int i=0; i<row; i++){
		for(int j=0; j<col; j++){
			
			if(basin[i][j] > 0 && basin[i][j] != dammy){
				*(upperGridNum+k) = basin[i][j];
				dammy = basin[i][j];
				k++;
			}
		}
	}

	for(int i=0; i<row; i++){
		delete[] basin[i];
	}
	delete[] basin;

	return num;
}
*/

void read2DValue(ROF** fROF, int Ndays, int ROFnum_row, int ROFnum_col)
{
	// read input data file arranged for two dimensional data. 

	char ROFfilename[256];

	//sprintf_s(ROFfilename, 256, "./input/rain.dat");
	sprintf(ROFfilename, "./input/rain.dat");
	cout << "Read " << ROFfilename << endl;

	ifstream fin(ROFfilename);
	if(!fin){
		cout << "ROF file cannot open.\n";
		exit(1);
	}

	int year, month, day, hour, xcol, yrow;
	for(int iday=1; iday <= Ndays; iday++){
		for(int ihour=0; ihour<24; ihour++){
			fin >> year >> month >> day >> hour >> xcol >> yrow;
			for(int i=ROFnum_row-1; i>=0; i--){
				for(int j=0; j<ROFnum_col; j++){
					fin >> fROF[i][j].value[iday][ihour] ;
				}
			}
		}
	}

	fin.close();
}


void read2DValueGrads(ROF** fROF, int Ndays, int ROFnum_row, int ROFnum_col)
{
	// read input data file arranged for two dimensional data. 

	char ROFfilename[256];

	//sprintf_s(ROFfilename, 256, "./input/rain.bin");
	sprintf(ROFfilename, "./input/rain.bin");
	cout << "Read " << ROFfilename << endl;

	ifstream fin(ROFfilename);
	if(!fin){
		cout << "ROF file cannot open.\n";
		exit(1);
	}
	
/*	
	// ǂݍݎԒZk̂߁C1Pʎԕ̑Sf[^xɓǂ
	// 2016/11/10 T. Tanaka
	float *rainAllCell = new float [ROFnum_row*ROFnum_col];
	for(int iday=1; iday <= Ndays; iday++) {
		for(int ihour=0; ihour<24; ihour++){  // hour loop
			fin.read((char*)rainAllCell, sizeof(float)*ROFnum_row*ROFnum_col);

			// fROF arrays from south
			for(int i=0; i<ROFnum_row; i++){  // 1st row data is the southest row!
				for(int j=0; j<ROFnum_col; j++){  // 1st column is the westest column!
					fROF[i][j].value[iday][ihour] = rainAllCell[i*ROFnum_col + j];
				}
			}
		}
	}
*/	
	// xɓǂ܂ȂƂƂ̓ǂݕ
	float rain;
	for(int iday=1; iday <= Ndays; iday++) {
		for(int ihour=0; ihour<24; ihour++) {
			for(int i=0; i<ROFnum_row; i++) {  // Grads f[^͓삩ԁB
			//for(int i=ROFnum_row-1; i>=0; i--) { // Text f[^͖kԁB
				for(int j=0; j<ROFnum_col; j++){
					fin.read((char*)&rain, sizeof(float));
					fROF[i][j].value[iday][ihour] = rain;
				}
			}
		}
	}
	fin.close();
}


